# MCP Tools Reference: compute.googleapis.com

## Tool: `list_instance_attached_disks`

Lists the disks attached to a Compute Engine virtual machine (VM) instance. For each attached disk, the response includes details such as kind, type, mode, saved state, source, device name, index, boot, initialize parameters, auto delete, licenses,, interface, guest OS features, disk encryption key, disk size, shielded instance initial state, force attach, and architecture. Requires project, zone, and instance name as input.

The following sample demonstrate how to use `curl` to invoke the `list_instance_attached_disks` MCP tool.

| Curl Request |
|---|
| ```bash curl --location 'https://compute.googleapis.com/mcp' \ --header 'content-type: application/json' \ --header 'accept: application/json, text/event-stream' \ --data '{ "method": "tools/call", "params": { "name": "list_instance_attached_disks", "arguments": { // provide these details according to the tool's MCP specification } }, "jsonrpc": "2.0", "id": 1 }' ``` |

## Input Schema

Request message for listing instance attached disks.

### McpListInstanceAttachedDisksRequest

| JSON representation |
|---|
| ``` { "project": string, "zone": string, "name": string } ``` |

| Fields ||
|---|---|
| `project` | `string` Required. Project ID for this request. |
| `zone` | `string` Required. The zone of the instance. |
| `name` | `string` Required. Identifier. The instance name. |

## Output Schema

Response message for listing instance attached disks.

### McpListInstanceAttachedDisksResponse

| JSON representation |
|---|
| ``` { "attachedDisks": [ { object (`https://docs.cloud.google.com/compute/docs/reference/mcp/tools_list/list_instance_attached_disks#Output.Schema.AttachedDisk`) } ] } ``` |

| Fields ||
|---|---|
| `attachedDisks[]` | ``object (`https://docs.cloud.google.com/compute/docs/reference/mcp/tools_list/list_instance_attached_disks#Output.Schema.AttachedDisk`)`` The list of attached disks. |

### AttachedDisk

| JSON representation |
|---|
| ``` { "kind": string, "type": enum (`DiskType`), "mode": enum (`DiskMode`), "savedState": enum (`DiskSavedState`), "source": string, "deviceName": string, "index": integer, "boot": boolean, "initializeParams": { object (`https://docs.cloud.google.com/compute/docs/reference/mcp/tools_list/list_instance_attached_disks#Output.Schema.InitializeParams`) }, "autoDelete": boolean, "licenses": [ string ], "interface": enum (`DiskInterface`), "guestOsFeatures": [ { object (`https://docs.cloud.google.com/compute/docs/reference/mcp/tools_list/list_instance_attached_disks#Output.Schema.GuestOsFeature`) } ], "diskEncryptionKey": { object (`https://docs.cloud.google.com/compute/docs/reference/mcp/tools_list/list_instance_attached_disks#Output.Schema.CustomerEncryptionKey`) }, "diskSizeGb": string, "shieldedInstanceInitialState": { object (`https://docs.cloud.google.com/compute/docs/reference/mcp/tools_list/list_instance_attached_disks#Output.Schema.InitialStateConfig`) }, "forceAttach": boolean, "architecture": enum (`Architecture`) } ``` |

| Fields ||
|---|---|
| `kind` | `string` Output only. \[Output Only\] Type of the resource. Always `compute#attachedDisk` for attached disks. |
| `type` | ``enum (`DiskType`)`` Specifies the type of the disk, either `SCRATCH` or `PERSISTENT`. If not specified, the default is `PERSISTENT`. |
| `mode` | ``enum (`DiskMode`)`` The mode in which to attach this disk, either `READ_WRITE` or `READ_ONLY`. If not specified, the default is to attach the disk in `READ_WRITE` mode. |
| `savedState` | ``enum (`DiskSavedState`)`` Output only. For LocalSSD disks on VM Instances in STOPPED or SUSPENDED state, this field is set to `PRESERVED` if the LocalSSD data has been saved to a persistent location by customer request. (see the discard_local_ssd option on Stop/Suspend). Read-only in the api. |
| `source` | `string` Specifies a valid partial or full URL to an existing Persistent Disk resource. When creating a new instance boot disk, one of `initializeParams.sourceImage` or `initializeParams.sourceSnapshot` or `disks.source` is required. If desired, you can also attach existing non-root persistent disks using this property. This field is only applicable for persistent disks. Note that for InstanceTemplate, specify the disk name for zonal disk, and the URL for regional disk. |
| `deviceName` | `string` Specifies a unique device name of your choice that is reflected into the `/dev/disk/by-id/google-*` tree of a Linux operating system running within the instance. This name can be used to reference the device for mounting, resizing, and so on, from within the instance. If not specified, the server chooses a default device name to apply to this disk, in the form `persistent-disk-x`, where x is a number assigned by Google Compute Engine. This field is only applicable for persistent disks. |
| `index` | `integer` Output only. \[Output Only\] A zero-based index to this disk, where 0 is reserved for the boot disk. If you have many disks attached to an instance, each disk would have a unique index number. |
| `boot` | `boolean` Indicates that this is a boot disk. The virtual machine will use the first partition of the disk for its root filesystem. |
| `initializeParams` | ``object (`https://docs.cloud.google.com/compute/docs/reference/mcp/tools_list/list_instance_attached_disks#Output.Schema.InitializeParams`)`` \[Input Only\] Specifies the parameters for a new disk that will be created alongside the new instance. Use initialization parameters to create boot disks or local SSDs attached to the new instance. This property is mutually exclusive with the `source` property; you can only define one or the other, but not both. |
| `autoDelete` | `boolean` Specifies whether the disk will be auto-deleted when the instance is deleted (but not when the disk is detached from the instance). |
| `licenses[]` | `string` Output only. \[Output Only\] Any valid publicly visible licenses. |
| `interface` | ``enum (`DiskInterface`)`` Specifies the disk interface to use for attaching this disk, which is either `SCSI` or `NVME`. For most machine types, the default is `SCSI`. Local SSDs can use either NVME or SCSI. In certain configurations, persistent disks can use NVMe. For more information, see [About persistent disks](https://cloud.google.com/compute/docs/disks/persistent-disks). |
| `guestOsFeatures[]` | ``object (`https://docs.cloud.google.com/compute/docs/reference/mcp/tools_list/list_instance_attached_disks#Output.Schema.GuestOsFeature`)`` A list of features to enable on the guest operating system. Applicable only for bootable images. Read [Enabling guest operating system features](https://docs.cloud.google.com/compute/docs/images/create-delete-deprecate-private-images#guest-os-features) to see a list of available options. |
| `diskEncryptionKey` | ``object (`https://docs.cloud.google.com/compute/docs/reference/mcp/tools_list/list_instance_attached_disks#Output.Schema.CustomerEncryptionKey`)`` Encrypts or decrypts a disk using a [customer-supplied encryption key](https://docs.cloud.google.com/compute/docs/disks/customer-supplied-encryption). If you are creating a new disk, this field encrypts the new disk using an encryption key that you provide. If you are attaching an existing disk that is already encrypted, this field decrypts the disk using the customer-supplied encryption key. If you encrypt a disk using a customer-supplied key, you must provide the same key again when you attempt to use this resource at a later time. For example, you must provide the key when you create a snapshot or an image from the disk or when you attach the disk to a virtual machine instance. If you do not provide an encryption key, then the disk will be encrypted using an automatically generated key and you do not need to provide a key to use the disk later. Note: Instance templates do not store [customer-supplied encryption keys](https://docs.cloud.google.com/compute/docs/disks/customer-supplied-encryption), so you cannot use your own keys to encrypt disks in a [managed instance group](https://docs.cloud.google.com/compute/docs/instance-groups). You cannot create VMs that have disks with customer-supplied keys using the [bulk insert method](https://docs.cloud.google.com/compute/docs/reference/rest/v1/instances/bulkInsert). |
| `diskSizeGb` | `string (https://developers.google.com/discovery/v1/type-format format)` The size of the disk in GB. |
| `shieldedInstanceInitialState` | ``object (`https://docs.cloud.google.com/compute/docs/reference/mcp/tools_list/list_instance_attached_disks#Output.Schema.InitialStateConfig`)`` Output only. \[Output Only\] shielded vm initial state stored on disk |
| `forceAttach` | `boolean` \[Input Only\] Whether to force attach the regional disk even if it's currently attached to another instance. If you try to force attach a zonal disk to an instance, you will receive an error. |
| `architecture` | ``enum (`Architecture`)`` Output only. \[Output Only\] The architecture of the attached disk. Valid values are ARM64 or X86_64. |

### InitializeParams

| JSON representation |
|---|
| ``` { "diskName": string, "sourceImage": string, "diskSizeGb": string, "diskType": string, "sourceImageEncryptionKey": { object (`https://docs.cloud.google.com/compute/docs/reference/mcp/tools_list/list_instance_attached_disks#Output.Schema.CustomerEncryptionKey`) }, "labels": { string: string, ... }, "sourceSnapshot": string, "sourceSnapshotEncryptionKey": { object (`https://docs.cloud.google.com/compute/docs/reference/mcp/tools_list/list_instance_attached_disks#Output.Schema.CustomerEncryptionKey`) }, "description": string, "replicaZones": [ string ], "resourcePolicies": [ string ], "onUpdateAction": enum (`OnUpdateAction`), "provisionedIops": string, "licenses": [ string ], "architecture": enum (`Architecture`), "resourceManagerTags": { string: string, ... }, "provisionedThroughput": string, "enableConfidentialCompute": boolean, "storagePool": string } ``` |

| Fields ||
|---|---|
| `diskName` | `string` Specifies the disk name. If not specified, the default is to use the name of the instance. If a disk with the same name already exists in the given region, the existing disk is attached to the new instance and the new disk is not created. |
| `sourceImage` | `string` The source image to create this disk. When creating a new instance boot disk, one of `initializeParams.sourceImage` or `initializeParams.sourceSnapshot` or `disks.source` is required. To create a disk with one of the [public operating system images](https://docs.cloud.google.com/compute/docs/images/os-details), specify the image by its family name. For example, specify `family/debian-9` to use the latest Debian 9 image: `projects/debian-cloud/global/images/family/debian-9` <br /> Alternatively, use a specific version of a public operating system image: `projects/debian-cloud/global/images/debian-9-stretch-vYYYYMMDD` <br /> To create a disk with a custom image that you created, specify the image name in the following format: `global/images/my-custom-image` <br /> You can also specify a custom image by its image family, which returns the latest version of the image in that family. Replace the image name with `family/family-name`: `global/images/family/my-image-family` <br /> If the source image is deleted later, this field will not be set. |
| `diskSizeGb` | `string (https://developers.google.com/discovery/v1/type-format format)` Specifies the size of the disk in base-2 GB. The size must be at least 10 GB. If you specify a `sourceImage`, which is required for boot disks, the default size is the size of the `sourceImage`. If you do not specify a `sourceImage`, the default disk size is 500 GB. |
| `diskType` | `string` Specifies the disk type to use to create the instance. If not specified, the default is `pd-standard`, specified using the full URL. For example: `https://www.googleapis.com/compute/v1/projects/project/zones/zone/diskTypes/pd-standard` <br /> For a full list of acceptable values, see [Persistent disk types](https://docs.cloud.google.com/compute/docs/disks#disk-types). If you specify this field when creating a VM, you can provide either the full or partial URL. For example, the following values are valid: - `https://www.googleapis.com/compute/v1/projects/project/zones/zone/diskTypes/diskType` - `projects/project/zones/zone/diskTypes/diskType` - `zones/zone/diskTypes/diskType` If you specify this field when creating or updating an instance template or all-instances configuration, specify the type of the disk, not the URL. For example: `pd-standard`. <br /> |
| `sourceImageEncryptionKey` | ``object (`https://docs.cloud.google.com/compute/docs/reference/mcp/tools_list/list_instance_attached_disks#Output.Schema.CustomerEncryptionKey`)`` The [customer-supplied encryption key](https://docs.cloud.google.com/compute/docs/disks/customer-supplied-encryption) of the source image. Required if the source image is protected by a customer-supplied encryption key. InstanceTemplate and InstancePropertiesPatch do not store [customer-supplied encryption keys](https://docs.cloud.google.com/compute/docs/disks/customer-supplied-encryption), so you cannot create disks for instances in a [managed instance group](https://docs.cloud.google.com/compute/docs/instance-groups) if the source images are encrypted with your own keys. |
| `labels` | `map (key: string, value: string)` Labels to apply to this disk. These can be later modified by the `disks.setLabels` method. This field is only applicable for persistent disks. An object containing a list of `"key": value` pairs. Example: `{ "name": "wrench", "mass": "1.3kg", "count": "3" }`. |
| `sourceSnapshot` | `string` The source snapshot to create this disk. When creating a new instance boot disk, one of `initializeParams.sourceSnapshot` or `initializeParams.sourceImage` or `disks.source` is required. To create a disk with a snapshot that you created, specify the snapshot name in the following format: `global/snapshots/my-backup` <br /> If the source snapshot is deleted later, this field will not be set. Note: You cannot create VMs in bulk using a snapshot as the source. Use an image instead when you create VMs using the [bulk insert method](https://docs.cloud.google.com/compute/docs/reference/rest/v1/instances/bulkInsert). |
| `sourceSnapshotEncryptionKey` | ``object (`https://docs.cloud.google.com/compute/docs/reference/mcp/tools_list/list_instance_attached_disks#Output.Schema.CustomerEncryptionKey`)`` The [customer-supplied encryption key](https://docs.cloud.google.com/compute/docs/disks/customer-supplied-encryption) of the source snapshot. |
| `description` | `string` An optional description. Provide this property when creating the disk. |
| `replicaZones[]` | `string` Required for each regional disk associated with the instance. Specify the URLs of the zones where the disk should be replicated to. You must provide exactly two replica zones, and one zone must be the same as the instance zone. |
| `resourcePolicies[]` | `string` Resource policies applied to this disk for automatic snapshot creations. Specified using the full or partial URL. For instance template, specify only the resource policy name. |
| `onUpdateAction` | ``enum (`OnUpdateAction`)`` Specifies which action to take on instance update with this disk. Default is to use the existing disk. |
| `provisionedIops` | `string (https://developers.google.com/discovery/v1/type-format format)` Indicates how many IOPS to provision for the disk. This sets the number of I/O operations per second that the disk can handle. Values must be between 10,000 and 120,000. For more details, see the [Extreme persistent disk documentation](https://docs.cloud.google.com/compute/docs/disks/extreme-persistent-disk). |
| `licenses[]` | `string` A list of publicly visible licenses. Reserved for Google's use. |
| `architecture` | ``enum (`Architecture`)`` The architecture of the attached disk. Valid values are arm64 or x86_64. |
| `resourceManagerTags` | `map (key: string, value: string)` Input only. Resource manager tags to be bound to the disk. Tag keys and values have the same definition as [resource manager tags](https://cloud.google.com/resource-manager/docs/tags/tags-overview). Keys and values can be either in numeric format, such as `tagKeys/{tag_key_id}` and `tagValues/{tag_value_id}` or in namespaced format such as `{org_id|project_id}/{tag_key_short_name}` and `{tag_value_short_name}`. The field is ignored (both PUT \& PATCH) when empty. An object containing a list of `"key": value` pairs. Example: `{ "name": "wrench", "mass": "1.3kg", "count": "3" }`. |
| `provisionedThroughput` | `string (https://developers.google.com/discovery/v1/type-format format)` Indicates how much throughput to provision for the disk. This sets the number of throughput mb per second that the disk can handle. Values must greater than or equal to 1. |
| `enableConfidentialCompute` | `boolean` Whether this disk is using confidential compute mode. |
| `storagePool` | `string` The storage pool in which the new disk is created. You can provide this as a partial or full URL to the resource. For example, the following are valid values: - `https://www.googleapis.com/compute/v1/projects/project/zones/zone/storagePools/storagePool` - `projects/project/zones/zone/storagePools/storagePool` - `zones/zone/storagePools/storagePool` <br /> |

### CustomerEncryptionKey

| JSON representation |
|---|
| ``` { "sha256": string, "kmsKeyServiceAccount": string, // Union field `key` can be only one of the following: "rawKey": string, "rsaEncryptedKey": string, "kmsKeyName": string // End of list of possible types for union field `key`. } ``` |

| Fields ||
|---|---|
| `sha256` | `string` \[Output only\] The [RFC 4648 base64](https://tools.ietf.org/html/rfc4648#section-4) encoded SHA-256 hash of the [customer-supplied encryption key](https://docs.cloud.google.com/compute/docs/disks/customer-supplied-encryption) that protects this resource. |
| `kmsKeyServiceAccount` | `string` The service account being used for the encryption request for the given KMS key. If absent, the Compute Engine default service account is used. For example: ```html "kmsKeyServiceAccount": "name@ project_id.iam.gserviceaccount.com/ ``` <br /> |
| Union field `key`. `key` can be only one of the following: ||
| `rawKey` | `string` Specifies a 256-bit [customer-supplied encryption key](https://docs.cloud.google.com/compute/docs/disks/customer-supplied-encryption), encoded in [RFC 4648 base64](https://tools.ietf.org/html/rfc4648#section-4) to either encrypt or decrypt this resource. You can provide either the `rawKey` or the `rsaEncryptedKey`. For example: ```html "rawKey": "SGVsbG8gZnJvbSBHb29nbGUgQ2xvdWQgUGxhdGZvcm0=" ``` <br /> |
| `rsaEncryptedKey` | `string` Specifies an RFC 4648 base64 encoded, RSA-wrapped 2048-bit [customer-supplied encryption key](https://docs.cloud.google.com/compute/docs/disks/customer-supplied-encryption#rsa-encryption) to either encrypt or decrypt this resource. You can provide either the `rawKey` or the `rsaEncryptedKey`. For example: ```html "rsaEncryptedKey": "ieCx/NcW06PcT7Ep1X6LUTc/hLvUDYyzSZPPVCVPTVEohpeHASqC8uw5TzyO9U+Fka9JFH z0mBibXUInrC/jEk014kCK/NPjYgEMOyssZ4ZINPKxlUh2zn1bV+MCaTICrdmuSBTWlUUiFoD D6PYznLwh8ZNdaheCeZ8ewEXgFQ8V+sDroLaN3Xs3MDTXQEMMoNUXMCZEIpg9Vtp9x2oe==" ``` The key must meet the following requirements before you can provide it to Compute Engine: 1. The key is wrapped using a RSA public key certificate provided by Google. 2. After being wrapped, the key must be encoded in [RFC 4648 base64](https://tools.ietf.org/html/rfc4648#section-4) encoding. Gets the RSA public key certificate provided by Google at: ```html https://cloud-certs.storage.googleapis.com/google-cloud-csek-ingress.pem ``` <br /> |
| `kmsKeyName` | `string` The name of the encryption key that is stored in Google Cloud KMS. For example: ```html "kmsKeyName": "projects/ kms_project_id/locations/ region/keyRings/ key_region/cryptoKeys/key ``` The fully-qualifed key name may be returned for resource GET requests. For example: ```html "kmsKeyName": "projects/ kms_project_id/locations/ region/keyRings/ key_region/cryptoKeys/key /cryptoKeyVersions/1 ``` <br /> |

### LabelsEntry

| JSON representation |
|---|
| ``` { "key": string, "value": string } ``` |

| Fields ||
|---|---|
| `key` | `string` |
| `value` | `string` |

### ResourceManagerTagsEntry

| JSON representation |
|---|
| ``` { "key": string, "value": string } ``` |

| Fields ||
|---|---|
| `key` | `string` |
| `value` | `string` |

### GuestOsFeature

| JSON representation |
|---|
| ``` { "type": enum (`FeatureType`) } ``` |

| Fields ||
|---|---|
| `type` | ``enum (`FeatureType`)`` The ID of a supported feature. To add multiple values, use commas to separate values. Set to one or more of the following values: - `VIRTIO_SCSI_MULTIQUEUE` - `WINDOWS` - `MULTI_IP_SUBNET` - `UEFI_COMPATIBLE` - `GVNIC` - `SEV_CAPABLE` - `SUSPEND_RESUME_COMPATIBLE` - `SEV_LIVE_MIGRATABLE_V2` - `SEV_SNP_CAPABLE` - `TDX_CAPABLE` - `IDPF` - `SNP_SVSM_CAPABLE` - `CCA_CAPABLE` For more information, see [Enabling guest operating system features](https://docs.cloud.google.com/compute/docs/images/create-delete-deprecate-private-images#guest-os-features). <br /> |

### InitialStateConfig

| JSON representation |
|---|
| ``` { "pk": { object (`https://docs.cloud.google.com/compute/docs/reference/mcp/tools_list/list_instance_attached_disks#Output.Schema.FileContentBuffer`) }, "keks": [ { object (`https://docs.cloud.google.com/compute/docs/reference/mcp/tools_list/list_instance_attached_disks#Output.Schema.FileContentBuffer`) } ], "dbs": [ { object (`https://docs.cloud.google.com/compute/docs/reference/mcp/tools_list/list_instance_attached_disks#Output.Schema.FileContentBuffer`) } ], "dbxs": [ { object (`https://docs.cloud.google.com/compute/docs/reference/mcp/tools_list/list_instance_attached_disks#Output.Schema.FileContentBuffer`) } ] } ``` |

| Fields ||
|---|---|
| `pk` | ``object (`https://docs.cloud.google.com/compute/docs/reference/mcp/tools_list/list_instance_attached_disks#Output.Schema.FileContentBuffer`)`` The Platform Key (PK). |
| `keks[]` | ``object (`https://docs.cloud.google.com/compute/docs/reference/mcp/tools_list/list_instance_attached_disks#Output.Schema.FileContentBuffer`)`` The Key Exchange Key (KEK). |
| `dbs[]` | ``object (`https://docs.cloud.google.com/compute/docs/reference/mcp/tools_list/list_instance_attached_disks#Output.Schema.FileContentBuffer`)`` The Key Database (db). |
| `dbxs[]` | ``object (`https://docs.cloud.google.com/compute/docs/reference/mcp/tools_list/list_instance_attached_disks#Output.Schema.FileContentBuffer`)`` The forbidden key database (dbx). |

### FileContentBuffer

| JSON representation |
|---|
| ``` { "content": string, "fileType": enum (`FileType`) } ``` |

| Fields ||
|---|---|
| `content` | `string (https://developers.google.com/discovery/v1/type-format format)` The raw content in the secure keys file. A base64-encoded string. |
| `fileType` | ``enum (`FileType`)`` The file type of source file. |

### Tool Annotations

Destructive Hint: ❌ \| Idempotent Hint: ✅ \| Read Only Hint: ✅ \| Open World Hint: ❌